esqui           segment
                assume cs:esqui,ds:esqui,es:esqui,ss:esqui
                org 100h
comienzo:       jmp menu_principal
nombre_programa db 'ESQUI.COM',0
mens_choque     db 30,24,'Crashhh!!! Apriete la barra espaciadora$'
mensm           db 7,24,'metros  Nivel$'
mens1           db 36,1,'DR-ESQUI$'
mens2           db 18,3,'Hecho por Daro Alejandro Alpern el 7/10/1990$'
mens3           db 33,7,'Tabla de Honor$'
mens4           db 34,21,'Velocidad (1-5):$'
mens5           db 23,23,'Entre cero para terminar el programa$'
mens6           db 29,24,'seis a nueve para demo$'
mens7           db 20,18,'Utilice la tecla CTRL para volver al men$'
mens8           db 28,19,'las teclas SHIFT para moverse$'
mens_record     db 45,24,'Nuevo rcord!!!$'
recuadro1       db 23,5,'ͻ$'
recuadro2       db 23,16,'ͼ$'
beep            db 79,24,7,7,'$'
buffer_nombre   db 21,0,'                     '
buffer_nivel    db 2,0,0,0
maximo          db '1) 000501 Daro               $'
                db '2) 000366 Daro               $'
                db '3) 000336 Daro               $'
                db '4) 000288 Daro               $'
                db '5) 000206 Daro               $'
metros          db 0,24,'000000$'
choque          db 0
demo            db 0
posrec          dw 0
lineas_mismos_arboles  db 0
reloj           db 0
espera_tics     db 0
nivel           db 0
cant_arboles    db 0
semilla         dw 0
esquiador       db 0
;
; Subrutina para actualizar la pantalla durante el juego y en demo.
;
actualizar_pantalla:  
                mov ax,0601h           ;Mover una lnea hacia arriba
                                       ;una regin de la pantalla.
                sub cx,cx              ;CH, CL = Fila superior y columna izq.
                mov dx,174Fh           ;DH, DL = Fila inferior y columna der.
                mov bh,7
                int 10h                ;Realizar el movimento de caracteres.
                mov cl,cant_arboles    ;CL = Cantidad de rboles por lnea.
                xor ch,ch              ;CX = Cantidad de rboles por lnea.
ciclo_poner_arboles:         
                push cx                ;Preservar contador de rboles.
                mov ax,semilla         ;AX = Semilla generador nros aleatorios.
                mov dx,75              ;Prxima semilla = (semilla * 75)
                mul dx                 ;                  mod 65537.
                and ax,ax              ;(si la semilla era cero, considerarla
                jnz semilla_no_cero    ;como 65536).
                mov dx,75
semilla_no_cero:sub ax,dx
                jnc guardar_semilla
                inc ax
guardar_semilla:mov semilla,ax         ;Preservar semiila.
                mov al,80
                mul ah                 ;AH = Nmero "aleatorio" entre 0 y 79.
                mov dh,23              ;DH = Fila a poner el rbol.
                mov dl,ah              ;DL = Columna a poner el rbol.
                xor bh,bh
                mov ah,2
                int 10h                ;Posicionar el cursor.
                mov ax,0A05h           ;05h = Carcter ASCII del rbol.
                xor bh,bh
                mov cx,1               ;Un slo carcter (no repetir).
                int 10h                ;Mostrar el rbol en pantalla.
                pop cx                 ;Restaurar el contador de rboles.
                loop ciclo_poner_arboles   ;Cerrar el ciclo.
                cmp demo,cl            ;Modo juego o modo demo?
                jz modo_juego          ;Saltar si el modo es juego.
                mov al,es:046Dh        ;El bit 0 cambia cada 14 segundos.
                ror al,1               ;Llevar este bit al Carry Flag.
                sbb al,al              ;Poner el acumulador en 00h  FFh.
                stc
                adc al,al              ;Poner el acumulador en 01h  FFh.
                mov demo,al            ;Almacenarlo. Si vale 01h el esqu se
                                       ;mover preferentemente a la derecha,
                                       ;en caso contrario a la izquierda,
                                       ;siempre que no pueda ir hacia abajo.
                mov al,esquiador       ;AL = Columna del esquiador.
                mov ah,0-1             ;AH = Nro. de lnea analizndose por
                                       ;debajo del esquiador para no chocar.
                call analizar_linea_inferior            
                                       ;Mover automticamente al esquiador.
                mov dl,esquiador       ;DL = Nueva columna del esquiador.
                jmp short mostrar_esqui;Ir a mostrar el esqu.
modo_juego:     mov ah,2               ;Obtener el estado de las teclas
                int 16h                ;SHIFT en bits 0 y 1 de AL.
                mov dl,esquiador       ;DL = Columna del esquiador.
                ror al,1               ;El jugador apret SHIFT derecho?
                jnc verif_SHIFT_izq    ;Saltar si no es as.
                cmp dl,79              ;Esquiador en la columna derecha?
                jz verif_SHIFT_izq     ;Saltar si es as.
                inc dl                 ;Una columna hacia la derecha.
verif_SHIFT_izq:ror al,1               ;El jugador apret SHIFT izquierdo?
                jnc guardar_col_esqui  ;Saltar si no es as.
                or dl,dl               ;Esquiador en la columna izquierda?
                jz guardar_col_esqui   ;Saltar si es as.
                dec dl                 ;Una columna hacia la izquierda.
guardar_col_esqui: mov esquiador,dl    ;Guardar la columna del esquiador.
mostrar_esqui:  xor dh,dh              ;Fila del esqu.
                mov ah,2
                int 10h                ;Posicionar el cursor.
                xor bh,bh
                mov ah,8               ;Leer el carcter en la posicin
                int 10h                ;del esqu.
                cmp al," "             ;Hay algn rbol?
                jz no_hubo_choque      ;Saltar si no es as.
                mov ax,0905h           ;05h = Carcter ASCII del rbol.
                mov bx,87h             ;Atributo blanco sobre negro + Flash.
                mov cx,1               ;Un slo carcter (no repetir).
                int 10h                ;Mostrar el rbol parpadeando.
                mov choque,1           ;Indicar que el esquiador choc.
                ret                    ;Fin de la subrutina.
no_hubo_choque: mov ax,0A48h           ;48h = Carcter ASCII del esquiador.
                xor bh,bh              
                mov cx,1               ;Un slo carcter (no repetir).
                int 10h                ;Mostrar el esqu.
                mov cx,6               ;Cantidad de dgitos de los metros.
                mov bx,offset metros[7] ;Puntero al dgito menos significativo
ciclo_act_metros:inc byte ptr [bx]     ;Incrementar la cantidad de metros.
                cmp byte ptr [bx],"9"  ;Dentro de rango?
                jbe mostrar_metros     ;Saltar si es as.
                mov byte ptr [bx],"0"  ;Poner el dgito a cero.
                dec bx                 ;Apuntar a sig. dgito ms significat.
                loop ciclo_act_metros  ;Cerrar ciclo.
mostrar_metros: mov bx,offset metros   ;Apuntar a la posicin a mostrar metros
                call mostrar_texto     ;Mostrar los metros en pantalla.
                cmp demo,0             ;Modo juego o modo demo?
                jnz act_info_arboles   ;Saltar si modo demo.
                push es                ;Preservar segmento extra.
                push cs
                pop es                 ;ES = Segmento de cdigo.
                mov si,posrec          ;SI = Puntero al rcord.
                mov di,offset metros[2] ;DI = Puntero a los metros.
                mov cx,6               ;CX = Cantidad de dgitos.
                rep cmpsb              ;Realizar la comparacin.
                pop es                 ;Restaurar segmento extra.
                jae act_info_arboles   ;Saltar si no se lleg al rcord.
                mov bx,offset mens_record ;Mostrar en la pantalla
                call mostrar_texto     ;que el jugador tiene el rcord.
act_info_arboles: dec lineas_mismos_arboles  ;Decrementar cantidad de lneas
                                       ;que faltan para incrementar la
                                       ;cantidad de rboles.
                jnz fin_subr           ;Saltar si faltan lneas.
                mov lineas_mismos_arboles,50  ;Ahora faltan 50 lneas.
                cmp cant_arboles,25    ;Verificar si se muestran 25 por lnea.
                jz fin_subr            ;Saltar si es as.
                inc cant_arboles       ;Incrementar cant de rboles por lnea.
fin_subr:       ret                    ;Final de la subrutina.
;
; Subrutina recursiva que indica para dnde tiene que ir el esquiador.
;
analizar_arboles:cmp al,80             ;Columna fuera de rango?
                jnc fin_subrut         ;Salir si es as.
                push ax                ;Preservar cantidad de lneas
                                       ;analizadas por debajo del esquiador
                                       ;y la columna del esquiador.
                mov dx,ax              ;DH = Fila y DL = Columna de anlisis.
                mov ah,2
                int 10h                ;Posicionar el cursor.
                mov ah,8
                xor bh,bh
                int 10h                ;AL = Carcter ASCII ledo all.
                cmp al,5               ;Verificar si hay un rbol.
                pop ax                 ;Restaurar cantidad de lneas
                                       ;analizadas por debajo del esquiador
                                       ;y la columna del esquiador.
                jz fin_subrut          ;Saltar si hay un rbol.
analizar_linea_inferior:         
                cmp ah,5               ;Se analizaron 5 lneas?
                jz no_hay_choque       ;Saltar si es as (no hay choque).
                push ax                ;Preservar cantidad de lneas
                                       ;analizadas por debajo del esquiador
                                       ;y la columna del esquiador.
                inc ah                 ;Incrementar cantidad de lneas.
                call analizar_arboles  ;Verificar si abajo hay un rbol.
                add al,demo
                call analizar_arboles  ;Verificar si abajo a la derecha (si
                                       ;demo = 1) o izquierda (si demo = -1)
                                       ;hay un rbol.
                sub al,demo
                sub al,demo
                call analizar_arboles  ;Verificar si abajo a la izquierda (si
                                       ;demo = 1) o derecha (si demo = -1)
                                       ;hay un rbol.
                pop ax                 ;Restaurar cantidad de lneas.
fin_subrut:     ret                    ;Fin de la subrutina.
no_hay_choque:  add sp,18              ;Restaurar el valor de SP.
                pop ax                 ;Obtener el valor de la columna del
                                       ;esquiador en AL.
                mov esquiador,al       ;Almacenar la columna del esquiador.
                pop ax                 ;Perder valores innecesarios que
                pop ax                 ;estaban en la pila.
                ret                    ;Fin de la subrutina.
;
; Subrutina para mostrar un texto en pantalla.
;
mostrar_texto:  mov dx,[bx]       ;Obtener fila (en DH) y columna (en DL) a
                                  ;presentar en pantalla el mensaje.
                push bx           ;Preservar el puntero a la posicin.
                xor bh,bh
                mov ah,2
                int 10h           ;Posicionar el cursor.
                pop dx            ;Restaurar el puntero a la posicin.
                inc dx
                inc dx            ;Puntero al texto.
                mov ah,9
                int 21h           ;Mostrar el texto.
                ret               ;Fin de la subrutina.
;
; Subrutina para borrar pantalla.
;
borrar_pantalla:mov ax,0600h            ;Borrar regin de la pantalla.
                mov bh,7                ;Atributo blanco sobre negro.
                xor cx,cx               ;Carcter superior izq. de la regin.
                mov dx,184Fh            ;Carcter inferior der. de la regin.
                int 10h                 ;Borrar toda la pantalla.
                ret                     ;Fin de la subrutina.
;
; Subrutina para mostrar la parte superior de la pantalla principal.
;
pantalla_principal:       
                call borrar_pantalla    ;Borrar la pantalla.
                mov bx,offset mens1     ;Mostrar mensajes zona superior
                call mostrar_texto      ;de la pantalla.
                mov bx,offset mens2
                call mostrar_texto
                mov bx,offset mens3
                call mostrar_texto
                mov bx,offset metros
                call mostrar_texto
                mov bx,offset recuadro1 ;Mostrar zona superior del recuadro
                call mostrar_texto      ;de la tabla de honor.
                mov bx,offset recuadro2 ;Mostrar zona inferior del recuadro
                call mostrar_texto      ;de la tabla de honor.
                mov cx,10               ;Cantidad de lneas del recuadro.
ciclo_recuadro: mov dl,23               ;Columna izquierda del recuadro.
                call mostrar_doble_linea_vertical
                mov dl,57               ;Columna derecha del recuadro.
                call mostrar_doble_linea_vertical
                loop ciclo_recuadro     ;Cerrar ciclo.
                mov cx,5                ;Cantidad rcords a mostrar.
                mov dx,offset maximo    ;DX = Puntero a tabla de mximos.
ciclo_mostrar_records:          
                push cx                 ;Preservar contador rcords.
                push dx                 ;Preservar puntero a tabla de mximos.
                mov dx,0F19h            ;Columna 25.
                sub dh,cl               ;Fila segn el nivel.
                xor bh,bh
                mov ah,2                ;Posicionar el cursor.
                int 10h
                pop dx                  ;DX = Puntero a tabla de mximos.
                push dx                 ;Preservar puntero a tabla de mximos.
                mov ah,9                ;Mostrar una lnea de rcord.
                int 21h
                pop dx                  ;DX = Puntero a tabla de mximos.
                pop cx                  ;CX = Contador rcords.
                add dx,31               ;DX = Puntero a siguiente lnea.
                loop ciclo_mostrar_records  ;Cerrar ciclo.
                ret                     ;Fin subrutina.
mostrar_doble_linea_vertical:
                push cx                 ;Preservar contador rcords.
                mov dh,5
                add dh,cl               ;Fila dependiendo del contador.
                xor bh,bh
                mov ah,2
                int 10h                 ;Posicionar cursor.
                mov ax,0ABAh            ;0BAH = ASCII doble lnea vertical.
                xor bh,bh
                mov cx,1                ;Un slo carcter (no repetirlo).
                int 10h                 ;Mostrar la doble lnea vertical.
                pop cx                  ;Restaurar contador rcords.
                ret                     ;Fin subrutina.
;
;  Mostrar el men principal.
;
menu_principal: call pantalla_principal ;Mostrar pantalla principal.
                mov bx,offset mens4     ;Mostrar parte inferior del
                call mostrar_texto      ;men principal.
                mov bx,offset mens5
                call mostrar_texto
                mov bx,offset mens6
                call mostrar_texto
                mov bx,offset mens7
                call mostrar_texto
                mov bx,offset mens8
                call mostrar_texto
entrar_nivel:   mov dx,1532h            ;Poner cursor en fila 15h
                xor bh,bh               ;y columna 32h para poder
                mov ah,2                ;entrar el nivel.
                int 10h
                mov dx,offset buffer_nivel  ;Vaciar buffer de teclado y 
                mov ax,0C0Ah            ;permitir que el jugador entre
                int 21h                 ;el nivel.
                mov al,buffer_nivel[2]  ;AL = Nivel (en ASCII).
                cmp al,"0"              ;Si el nivel no es cero,
                jnz no_terminar_prog    ;seguir.
                call borrar_pantalla    ;Borrar la pantalla.
                mov ax,4C00h            ;Finalizar el programa.
                int 21h
no_terminar_prog:jc entrar_nivel        ;Si esta fuera de rango, volver a
                                        ;entrar el nivel.
                cmp al,"9"              ;Si esta fuera de rango, volver a
                ja entrar_nivel         ;entrar el nivel.
                mov demo,0              ;Suponer que no se pidi demo.
                mov ah,"6"              ;Calcular la velocidad.
                sub ah,al              
                ja velocidad_calculada  ;Si el nivel vale entre 1 y 5,
                                        ;no hay demo. Almacenarla.
                add ah,4                ;Convertir a nmero de nivel.
                inc demo                ;Indicar que se pidi demo.
velocidad_calculada:        
                mov nivel,ah            ;Almacenar el nmero de nivel.
                mov semilla,0           ;Inicializar la semilla para el
                                        ;generador de nmeros aleatorios.
                mov esquiador,40        ;Posicin del esquiador.
                mov cant_arboles,1      ;Cantidad de rboles por lnea.
                mov choque,0            ;Poner indicador de choque a cero.
                mov espera_tics,1       ;Cantidad de tics a esperar antes
                                        ;de mover la pantalla hacia arriba.
                mov lineas_mismos_arboles,50  ;Cantidad de lneas que faltan
                                        ;para cambiar la cantidad de rboles.
                sub al,"1"              ;AL = Indice segn nivel.
                mov ah,31               ;Longitud de la lnea del rcord.
                mul ah                  ;AX = Indice al principio de la lnea
                                        ;del rcord para el nivel pedido.
                add ax,offset maximo[3] ;AX = Puntero al rcord.
                mov posrec,ax           ;Almacenar el puntero.
                mov bx,offset metros[2] ;Inicializar el contador de metros.
                mov cx,6                ;Seis dgitos para los metros.
ciclo_inic_metros:  mov byte ptr [bx],"0"   ;Poner el carcter a cero.
                inc bx                  ;Apuntar al prximo carcter.
                loop ciclo_inic_metros  ;Cerrar el ciclo.
                call borrar_pantalla    ;Borrar la pantalla.
;
; Comienzo del juego.
;
                mov bx,offset mensm     ;Mostrar los textos "metros" y
                call mostrar_texto      ;"Nivel".
                mov dx,1815h            ;El nivel se debe mostrar en la
                xor bh,bh               ;fila 18h, columna 15h.
                mov ah,2
                int 10h
                mov ax,0A36h
                sub al,nivel            ;AL = Nivel en ASCII.
                mov bx,7                ;Frente blanco sobre fondo negro.
                mov cx,1                ;Un slo carcter (no repetir).
                int 10h                 ;Mostrar el nivel.
                xor ax,ax
                mov es,ax               ;ES = Segmento cero.
                mov al,es:046ch         ;Obtener el tic de reloj de BIOS.
                mov reloj,al            ;Almacenarlo.
ciclo_principal:mov ah,2                ;Obtener el estado de las teclas
                int 16h                 ;SHIFT.
                and al,4                ;Se apret alguna tecla CTRL?
                jz no_apreto_CTRL       ;Saltar si no es as.
                jmp menu_principal      ;Volver al men principal.
no_apreto_CTRL: mov al,es:046Ch         ;Obtener el tic de reloj de BIOS.
                cmp reloj,al            ;Compararlo contra el anterior.
                jz ciclo_principal      ;Volver si no cambi.
                mov reloj,al            ;Actualizar el tic de reloj.
                dec espera_tics         ;Ver si pas el tiempo segn el nivel.
                jnz ciclo_principal     ;Volver si no es as.
                mov al,nivel            ;Esperar nuevamente segn el nivel.
                mov espera_tics,al
                call actualizar_pantalla ;Actualizar la pantalla.
                mov ah,2                ;Poner el cursor fuera de la pantalla.
                mov dx,1A00h
                xor bx,bx
                int 10h
                cmp choque,1            ;El esquiador choc contra un rbol?   
                jnz ciclo_principal     ;Volver si no es as.
;
; Fin del juego.
;
                mov bx,offset mens_choque  ;Mostrar mensaje de choque.
                call mostrar_texto
                mov bx,offset beep      ;Generar sonido.
                call mostrar_texto
esperar_espacio:xor ah,ah               ;Esperar a que el jugador apriete
                int 16h                 ;alguna tecla.
                cmp al," "              ;Es la barra espaciadora?
                jnz esperar_espacio     ;Seguir esperando si no es as.
                push cs
                pop es                  ;ES = Segmento de cdigo.
                mov si,posrec           ;SI = Puntero al rcord.
                mov di,offset metros[2] ;DI = Puntero a la cantidad de metros.
                mov cx,6                ;CX = Cantidad de dgitos a comparar.
                cld                     ;La cadena se debe procesar en
                                        ;direcciones ascendentes.
                rep cmpsb               ;Realizar la comparacin.
                jae ir_a_menu_principal ;Saltar si no es rcord.
                mov si,offset metros[2] ;SI = Puntero a la cantidad de metros.
                mov di,posrec           ;DI = Puntero al rcord.
                mov cx,3                ;CX = Cantidad de palabras a mover.
                rep movsw               ;Poner el nuevo rcord.
                mov al," "              ;Rellenar con espacios.
                mov cl,21               ;Cantidad de caracteres.
                rep stosb               ;Borrar el nombre anterior.
                call pantalla_principal ;Mostrar parte sup. pantalla principal.
                mov dx,0F23h
                sub dh,nivel            ;Posicin del cursor segn el nivel.
                xor bh,bh
                mov ah,2
                int 10h                 ;Posicionar el cursor.
entrar_nombre:  mov dx,offset buffer_nombre  ;Vaciar buffer de teclado y 
                mov ax,0C0Ah            ;permitir que el jugador entre
                int 21h                 ;su nombre.
                mov cl,buffer_nombre[1] ;CL = Cantidad de caracteres entrados.
                or cl,cl                ;Hubo alguno?
                jz entrar_nombre        ;Entrar de nuevo si no se entr nada.
                xor ch,ch               ;Extender a 16 bits.
                mov si,offset buffer_nombre[2] ;SI = Puntero al nombre entrado.
                mov di,posrec           ;DI = Puntero al rcord.
                add di,7                ;DI = Puntero al nuevo nombre.
                rep movsb               ;Poner el nuevo nombre.
                mov ah,3Ch              ;Abrir el archivo ejecutable del
                mov dx,offset nombre_programa  ;programa truncndolo a cero
                int 21h                 ;bytes.
                jc ir_a_menu_principal  ;Volver a men principal si no se
                                        ;puede abrir el archivo.
                mov bx,ax               ;BX = Handle del archivo.
                mov cx,fin_programa - comienzo ;CX = Longitud del programa.
                mov dx,offset comienzo  ;DX = Comienzo del programa.
                mov ah,40h              ;Escribir el programa en el disco.
                int 21h
                jc final_anormal        ;Saltar si no se pudo.
                mov ah,3eh              ;Cerrar el archivo.
                int 21h
                jc final_anormal        ;Saltar si no se pudo.
ir_a_menu_principal:
                jmp menu_principal      ;Volver al men principal.
final_anormal:  mov ah,3eh              ;Cerrar el archivo.
                int 21h
                mov ax,4c01h            ;Indicar final anormal del programa.
                int 21h
fin_programa    equ $
esqui           ends
                end comienzo
